# Class OjTable

The component WebElement for oj-table. Do not instantiate this class directly, instead, use ojTable.

#### Hierarchy

- OjTableBase
  - OjTable

#####
Index

### Constructors

constructor

### Methods

changeColumns
changeCurrentRow
changeEditRow
changeScrollPosition
changeSelected
changeSelection
clear
click
doSort
findCell
findElement
findElements
findFooter
findHeader
findRow
getAccessibility
getAddRowDisplay
getAs
getAttribute
getColumns
getColumnsDefault
getCssValue
getCurrentRow
getDisplay
getDnd
getDriver
getEditMode
getEditRow
getFirstSelectedRow
getHorizontalGridVisible
getId
getLayout
getLocation
getProperty
getRect
getRow
getRowRenderer
getScrollPolicy
getScrollPolicyOptions
getScrollPosition
getScrollToKey
getSelectAllControl
getSelected
getSelection
getSelectionMode
getSelectionRequired
getShadowRoot
getSize
getTagName
getText
getTranslations
getVerticalGridVisible
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjTable(el, locators): OjTable

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjTable

  Inherited from OjTableBase.constructor

## Methods

### changeColumns

- changeColumns(columns): Promise<void>

- Sets the value of `columns` property. An array of column definitions. See the Help documentation for more information.

  #### Parameters

  - ##### columns: Columns[]

    The value to set for `columns`

  #### Returns Promise<void>

  Inherited from OjTableBase.changeColumns

### changeCurrentRow

- changeCurrentRow(currentRow): Promise<void>

- Sets the value of `currentRow` property. Specifies the row that currently has keyboard focus. See the Help documentation for more information.

  #### Parameters

  - ##### currentRow: object

    The value to set for `currentRow`

  #### Returns Promise<void>

  Inherited from OjTableBase.changeCurrentRow

### changeEditRow

- changeEditRow(editRow): Promise<void>

- Sets the value of `editRow` property. Specifies the row that is currently being edited. See the Help documentation for more information.

  #### Parameters

  - ##### editRow: object

    The value to set for `editRow`

  #### Returns Promise<void>

  Inherited from OjTableBase.changeEditRow

### changeScrollPosition

- changeScrollPosition(scrollPosition): Promise<void>

- Sets the value of `scrollPosition` property. Specifies the scroll position of the table. See the Help documentation for more information.

  #### Parameters

  - ##### scrollPosition: ScrollPosition

    The value to set for `scrollPosition`

  #### Returns Promise<void>

  Inherited from OjTableBase.changeScrollPosition

### changeSelected

- changeSelected<K>(selected): Promise<void>

- Sets the value of "selected" property. Specifies the current selected rows and/or columns in the table. See the Help documentation for more information.

  ### Typeparam

  K Type of keys

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### selected: {
    column: K[];
    row: K[];
    }

    The value to set for "selected"

    - ##### column: K[]

    - ##### row: K[]

  #### Returns Promise<void>

  Overrides OjTableBase.changeSelected

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. Specifies the current selections in the table. See the Help documentation for more information.

  ### Deprecated

  Since 7.0.0. Use selected attribute instead.

  #### Parameters

  - ##### selection: object[]

    The value to set for `selection`

  #### Returns Promise<void>

  Inherited from OjTableBase.changeSelection

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjTableBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjTableBase.click

### doSort

- doSort(header, direction): Promise<void>

- Sort the given column.

  #### Parameters

  - ##### header: string

    The key of the header which need to be sorted.

  - ##### direction: "ascending" | "descending"

    The direction of the sort.

  #### Returns Promise<void>

### findCell

- findCell<K>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a single cell. Should be used only if cell contents are rendered using cell template/renderer/slot. Otherwise method will throw an exception.

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### itemLocator: Object

    Either column index or key and row index or key of the cell.

  #### Returns Promise<SlotProxy>

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjTableBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjTableBase.findElements

### findFooter

- findFooter(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents the given footer cell. Should be used only if footer is rendered using template/renderer/slot. Otherwise method will throw an exception.

  #### Parameters

  - ##### itemLocator: {
    columnIndex: number;
    columnKey?: never;
    } | {
    columnIndex?: never;
    columnKey: string;
    }

    Either index or key of the footer cell.

  #### Returns Promise<SlotProxy>

### findHeader

- findHeader(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents the given header cell. Should be used only if header is rendered using template/renderer/slot. Otherwise method will throw an exception.

  #### Parameters

  - ##### itemLocator: {
    columnIndex: number;
    columnKey?: never;
    } | {
    columnIndex?: never;
    columnKey: string;
    }

    Either index or key of the header cell.

  #### Returns Promise<SlotProxy>

### findRow

- findRow<K>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a single row. Should be used only if row is rendered using rowTemplate slot or renderer. Otherwise method will throw an exception.

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### itemLocator: {
    rowIndex: number;
    rowKey?: never;
    } | {
    rowIndex?: never;
    rowKey: K;
    }

    Either index or key of the row.

  #### Returns Promise<SlotProxy>

### getAccessibility

- getAccessibility(): Promise<Accessibility>

- Gets the value of `accessibility` property. Accessibility attributes.

  #### Returns Promise<Accessibility>

  The value of `accessibility` property.

  Inherited from OjTableBase.getAccessibility

### getAddRowDisplay

- getAddRowDisplay(): Promise<string>

- Gets the value of `addRowDisplay` property. Specifies whether to show or hide add new row when addRowTemplate or addRowCellTemplate is present.

  #### Returns Promise<string>

  The value of `addRowDisplay` property.

  Inherited from OjTableBase.getAddRowDisplay

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to the content of the cell template.

  ### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  #### Returns Promise<string>

  The value of `as` property.

  Inherited from OjTableBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjTableBase.getAttribute

### getColumns

- getColumns(): Promise<Columns[]>

- Gets the value of `columns` property. An array of column definitions. See the Help documentation for more information.

  #### Returns Promise<Columns[]>

  The value of `columns` property.

  Inherited from OjTableBase.getColumns

### getColumnsDefault

- getColumnsDefault(): Promise<ColumnsDefault>

- Gets the value of `columnsDefault` property. Default values to apply to all column objects.

  #### Returns Promise<ColumnsDefault>

  The value of `columnsDefault` property.

  Inherited from OjTableBase.getColumnsDefault

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjTableBase.getCssValue

### getCurrentRow

- getCurrentRow(): Promise<object>

- Gets the value of `currentRow` property. Specifies the row that currently has keyboard focus. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `currentRow` property.

  Inherited from OjTableBase.getCurrentRow

### getDisplay

- getDisplay(): Promise<string>

- Gets the value of `display` property. Specifies whether to display this table in list or grid mode. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `display` property.

  Inherited from OjTableBase.getDisplay

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Specifies drag and drop features. See the Help documentation for more information.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

  Inherited from OjTableBase.getDnd

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjTableBase.getDriver

### getEditMode

- getEditMode(): Promise<string>

- Gets the value of `editMode` property. Specifies if the table is read-only or editable. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `editMode` property.

  Inherited from OjTableBase.getEditMode

### getEditRow

- getEditRow(): Promise<object>

- Gets the value of `editRow` property. Specifies the row that is currently being edited. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `editRow` property.

  Inherited from OjTableBase.getEditRow

### getFirstSelectedRow

- getFirstSelectedRow(): Promise<FirstSelectedRow>

- Gets the value of `firstSelectedRow` property. Read-only property used for retrieving the key and data of the first selected row. See the Help documentation for more information.

  #### Returns Promise<FirstSelectedRow>

  The value of `firstSelectedRow` property.

  Inherited from OjTableBase.getFirstSelectedRow

### getHorizontalGridVisible

- getHorizontalGridVisible(): Promise<string>

- Gets the value of `horizontalGridVisible` property. Specifies the visibility of the horizontal gridlines. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `horizontalGridVisible` property.

  Inherited from OjTableBase.getHorizontalGridVisible

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjTableBase.getId

### getLayout

- getLayout(): Promise<string>

- Gets the value of `layout` property. The column sizing method used for the Table and its columns.

  #### Returns Promise<string>

  The value of `layout` property.

  Inherited from OjTableBase.getLayout

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjTableBase.getLocation

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjTableBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjTableBase.getRect

### getRow

- getRow(): Promise<Row>

- Gets the value of `row` property. Customizes the functionality of each row in the table.

  #### Returns Promise<Row>

  The value of `row` property.

  Inherited from OjTableBase.getRow

### getRowRenderer

- getRowRenderer(): Promise<null>

- Gets the value of `rowRenderer` property. A function that returns row content. The function takes a context argument, provided by the table. See the Help documentation for more information.

  #### Returns Promise<null>

  The value of `rowRenderer` property.

  Inherited from OjTableBase.getRowRenderer

### getScrollPolicy

- getScrollPolicy(): Promise<string>

- Gets the value of `scrollPolicy` property. Specifies how data are fetched as user scrolls down the table.

  #### Returns Promise<string>

  The value of `scrollPolicy` property.

  Inherited from OjTableBase.getScrollPolicy

### getScrollPolicyOptions

- getScrollPolicyOptions(): Promise<ScrollPolicyOptions>

- Gets the value of `scrollPolicyOptions` property. Specifies fetch options for scrolling behaviors that trigger data fetches.

  #### Returns Promise<ScrollPolicyOptions>

  The value of `scrollPolicyOptions` property.

  Inherited from OjTableBase.getScrollPolicyOptions

### getScrollPosition

- getScrollPosition(): Promise<ScrollPosition>

- Gets the value of `scrollPosition` property. Specifies the scroll position of the table. See the Help documentation for more information.

  #### Returns Promise<ScrollPosition>

  The value of `scrollPosition` property.

  Inherited from OjTableBase.getScrollPosition

### getScrollToKey

- getScrollToKey(): Promise<string>

- Gets the value of `scrollToKey` property. Specifies the behavior when Table needs to scroll to a position based on an item key.

  #### Returns Promise<string>

  The value of `scrollToKey` property.

  Inherited from OjTableBase.getScrollToKey

### getSelectAllControl

- getSelectAllControl(): Promise<string>

- Gets the value of `selectAllControl` property. Specifies the visibility of the select all control. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `selectAllControl` property.

  Inherited from OjTableBase.getSelectAllControl

### getSelected

- getSelected<K>(): Promise<{
  column: K[];
  row: K[];
  }>

- Gets the value of "selected" property. Specifies the current selected rows and/or columns in the table. See the Help documentation for more information.

  ### Typeparam

  K Type of keys

  #### Type Parameters

  - #### K

  #### Returns Promise<{
  column: K[];
  row: K[];
  }>

  The value of "selected" property.

  Overrides OjTableBase.getSelected

### getSelection

- getSelection(): Promise<object[]>

- Gets the value of `selection` property. Specifies the current selections in the table. See the Help documentation for more information.

  ### Deprecated

  Since 7.0.0. Use selected attribute instead.

  #### Returns Promise<object[]>

  The value of `selection` property.

  Inherited from OjTableBase.getSelection

### getSelectionMode

- getSelectionMode(): Promise<unknown>

- Gets the value of `selectionMode` property. Specifies the row and column selection modes.

  #### Returns Promise<unknown>

  The value of `selectionMode` property.

  Inherited from OjTableBase.getSelectionMode

### getSelectionRequired

- getSelectionRequired(): Promise<boolean>

- Gets the value of `selectionRequired` property. Specifies whether selection is required on the Table.

  #### Returns Promise<boolean>

  The value of `selectionRequired` property.

  Inherited from OjTableBase.getSelectionRequired

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjTableBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjTableBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjTableBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjTableBase.getText

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjTableBase.getTranslations

### getVerticalGridVisible

- getVerticalGridVisible(): Promise<string>

- Gets the value of `verticalGridVisible` property. Specifies the visibility of the vertical gridlines. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `verticalGridVisible` property.

  Inherited from OjTableBase.getVerticalGridVisible

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjTableBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjTableBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjTableBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjTableBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjTableBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjTableBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjTableBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjTableBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjTableBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjTableBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjTableBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjTableBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjTableBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjTableBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjTableBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjTableBase.isId

Generated using TypeDoc